**************************************************************************
*                                                                        *
*  Descripcin: Base para construir interfaces COM                       *
*                                                                        *
*  Autor: Jos F. Gimnez (JFG) - jfgimenez@wanadoo.es                   *
*                                 tecnico.sireinsa@ctv.es                *
*  Fecha: 13-3-2001                                                      *
*                                                                        *
**************************************************************************

#include "FiveWin.ch"


//--------------------------------------------------------------------------

CLASS IUnknown

   DATA hObj

   METHOD QueryInterface( IID )
   METHOD AddRef()                INLINE  OLEAddRef( ::hObj )
   METHOD Release()               INLINE  OLERelease( ::hObj )

ENDCLASS


METHOD QueryInterface( IID ) CLASS IUnknown

   LOCAL oObj, hObj

   hObj := OLEQueryInterface( ::hObj, IID[ 1 ] )
   oObj := EVal( IID[ 2 ] )
   oObj:hObj := hObj

RETURN oObj

//--------------------------------------------------------------------------

FUNCTION COMInterface_GenBlock( aParam, n )

   LOCAL b := "{|Self "

   AEVAL( aParam, {|p| b += ", " + IIF( LEFT( p, 1) == "@", SUBS( p, 2), p ) } )
   b += "| COMFunction( ::hObj, " + LTRIM( STR( n ) )
   AEVAL( aParam, {|p| b += ", " + p } )
   b += " ) }"

RETURN &(b)

EXTERNAL ComFunction

//--------------------------------------------------------------------------
